from profilelib.libraries.profile.manager import ProfileManager
from profilelib.libraries.profile.validations.profile import ProfileValidationRules
from libraries.system.logger import Log


class Profile():
    def patch(self):
        response: dict = dict()
        data: dict = dict()
        data["user_id"] = self.get_user('id')
        data["permanent_address"] = self.get_argument("permanent_address", None)
        data["temporary_address"] = self.get_argument("temporary_address", None)
        data["phone"] = self.get_argument("phone", None)
        data["mobile"] = self.get_argument("mobile", None)
        data["image"] = self.get_argument("image", None)
        data["alternate_email"] = self.get_argument("alternate_email", None)
        data["facebook"] = self.get_argument('facebook', None)
        data["twitter"] = self.get_argument('twitter', None)
        data["linkedin"] = self.get_argument('linkedin', None)
        data["preferences"] = self.get_argument('preferences', None)

        try:
            validation_rules = ProfileValidationRules()
            errors = validation_rules.user_profile_valiation(data)
            if len(errors):
                raise ValueError(errors)

            user_manager = ProfileManager()
            response = user_manager.update_profile(**data)
            if response["success_status"]:
                self.set_response_status(self.RESPONSE_STATUS_SUCCESS_TRUE)
            else:
                self.set_response_status(self.RESPONSE_STATUS_SUCCESS_FALSE)
            self.set_message(response['message'])

        except ValueError as e:
            self.set_message(str(e))
            self.set_status_code(400)
            self.set_response_status(self.RESPONSE_STATUS_SUCCESS_FALSE)

        except Exception as e:
            Log().entry(e)  # loggin error
            self.set_response_status(self.RESPONSE_STATUS_SUCCESS_FALSE)
        finally:
            self.set_data(response)
            self.send()