from spotlight.validator import Validator
from spotlight.rules import Rule
from libraries.currency.models import CurrencyModel
from libraries.system.logger import Log

class EmailTemplateValidationRules():
    def __init__(self):
        self.validator = Validator()

    def validate_create_email_template(self, data: dict) -> list:
        self.validator.register_rule(UniqueRule())
        rules = {
                "title": "required|string|max:255",
                "subject": "required|string|max:300",
                "content": "required|string",
                "type": "required|string"
            }
        return self.validator.validate(data, rules)


    def validate_update_email_template(self, data: dict) -> list:
        rules = {
                "title": "required|string|max:255",
                "subject": "required|string|max:300",
                "content": "required|string",
                "type": "required|string"
            }
        return self.validator.validate(data, rules)
