from spotlight.validator import Validator
from spotlight.rules import Rule

class ProfilelibCheckId(Rule):
    name = "profilelib_check_id"

    def passes(self, field: str, value: any, parameters, validator) -> bool:
        self.message_fields = dict(field=field)

        if int(parameters[0]) in [1,2]:
            return False
        else:
            return True

    @property
    def message(self) -> str:
        return "You can not delete this role."

class RoleValidationRules():
    def __init__(self):
        self.validator = Validator()

    def create_role_validations(self, data: dict):
        self.validator.register_rule(ProfilelibCheckId())
        rules={
            "name":'required|string|max:128',
            "description":"required|string|max:256"
        }
        return self.validator.validate(data, rules)

    def update_role_validations(self, data: dict):

        rules = {
            'id': 'required',
            "name": 'required|string|max:128',
            "description": "required|string|max:256"
        }
        return self.validator.validate(data, rules)

    def check_id(self, data: dict, id):
        self.validator.register_rule(ProfilelibCheckId())
        rules = {
            'id': 'required|profilelib_check_id:' + id
        }
        return self.validator.validate(data, rules)