import datetime
from libraries.system.model import BaseModel
from peewee import DateTimeField, TextField, CharField, BooleanField
from playhouse.postgres_ext import DateTimeTZField


class ApiKey(BaseModel):
    class Meta:
        table_name = "api_keys"
    app_name = CharField(unique=True, max_length=250, index=True)
    app_description = TextField(null=False)
    key = CharField(unique=True, max_length=250, index=True)
    secret = CharField(unique=True, max_length=250)
    expiry_date = DateTimeTZField(null=True, index=True)
    active = BooleanField(default=False)
    created_at = DateTimeTZField(default=datetime.datetime.now)
    updated_at = DateTimeTZField(default=datetime.datetime.now)


class Migration(BaseModel):
    def up(self):
        ApiKey.create_table()

    def down(self):
        ApiKey.drop_table(cascade=True)
