import datetime
from libraries.system.model import BaseModel
from profilelib.libraries.api.model import ApiKeyModel
from profilelib.libraries.user.model import UserModel
from peewee import IntegerField, DateTimeField, ForeignKeyField, CharField, BooleanField, TextField
from playhouse.postgres_ext import DateTimeTZField


class ApiToken(BaseModel):
    class Meta:
        table_name = "api_tokens"
    user_id = ForeignKeyField(UserModel, null=True, index=True, on_delete='CASCADE')
    api_key_id = ForeignKeyField(ApiKeyModel, index=True, on_delete='CASCADE')
    token = TextField(index=True)
    revoked = BooleanField(default=False)
    created_at = DateTimeTZField(default=datetime.datetime.now)
    updated_at = DateTimeTZField(default=datetime.datetime.now)


class Migration(BaseModel):
    def up(self):
        """ Create user table. """
        ApiToken.create_table()

    def down(self):
        ApiToken.drop_table(cascade=True)
