from libraries.system.model import BaseModel
from peewee import DateTimeField, CharField, datetime, BooleanField
from playhouse.postgres_ext import BinaryJSONField, DateTimeTZField


class TemplateModel(BaseModel):
    class Meta:
        table_name = 'templates'
    title = CharField()
    slug = CharField(index=True, unique=True)
    description = CharField(null=True)
    forms = BinaryJSONField(null=True)
    default = BooleanField(default=False)
    created_by = CharField(null=True)
    created_at = DateTimeTZField(default=datetime.datetime.now)
    updated_at = DateTimeTZField(default=datetime.datetime.now)


class Migration(BaseModel):
    def up(self):
        """ Create user table. """
        TemplateModel.create_table()

    def down(self):
        TemplateModel.drop_table(cascade=True)