from libraries.system.model import BaseModel
from peewee import DateTimeField, CharField, datetime, TextField
from playhouse.postgres_ext import DateTimeTZField


class RoleModel(BaseModel):
    class Meta:
        table_name = 'roles'

    role_types = {
        'default': 'System  Role',
        'app': 'Application defined role'
    }
    name = CharField(max_length=128)
    type = CharField(default='default', choices=[('default', 'System defined role'), ('app', "Application specific role")])
    slug = CharField(max_length=256, index=True)
    description = TextField(null=True)
    created_at = DateTimeTZField(default=datetime.datetime.now)
    updated_at = DateTimeTZField(default=datetime.datetime.now)


class Migration(BaseModel):
    def up(self):
        RoleModel.create_table()

    def down(self):
        RoleModel.drop_table(cascade=True)
