import datetime
from libraries.system.model import BaseModel
from profilelib.libraries.user.model import UserModel
from profilelib.libraries.role.model import RoleModel
from peewee import IntegerField, DateTimeField, ForeignKeyField
from playhouse.postgres_ext import DateTimeTZField


class UserRole(BaseModel):
    class Meta:
        table_name = "user_roles"
    user_id = ForeignKeyField(UserModel, index=True, on_delete='CASCADE')
    role_id = ForeignKeyField(RoleModel, index=True, on_delete='CASCADE')
    created_at = DateTimeTZField(default=datetime.datetime.now)
    updated_at = DateTimeTZField(default=datetime.datetime.now)


class Migration(BaseModel):
    def up(self):
        """ Create user table. """
        UserRole.create_table()

    def down(self):
        UserRole.drop_table(cascade=True)
