import sys, click, os, datetime
parent_dir = os.path.abspath(os.getcwd())
sys.path.append(parent_dir)
from libraries.system.application import Application

@click.group(chain=True)
def cli():
    pass

class DatabaseMigration(click.MultiCommand):

    def run_migration(self, action='up'):
        from profilelib.migration.manager import ProfilLibMigrationManager
        migrationManager = ProfilLibMigrationManager()
        migrationManager.set_migration_action(action)
        migrationManager.run()


@cli.command('run-migration')
@click.option('--env', help='Application environment')
@click.option('--action', help='Methods defined in migration', default='up')
def migrate(env, action):
    application = Application()
    application.set_application_environment(env)
    application.init_settings()

    dbMigrationTool = DatabaseMigration()
    dbMigrationTool.run_migration(action)

if __name__ == '__main__':
    cli()